import { Component, WebElement, type SimpleHTMLElement, html, cls, attribute } from '..'

@Component('bad-ge')
export default class Badge extends WebElement {

	@attribute()
	public badge?: WebElement

	@attribute()
	public class?: string

	public override async render(): Promise<SimpleHTMLElement> {
		return html`
			<div class=${cls(['px-4 py-1 text-center rounded-full relative flex', this.class])}>
				<div class="overflow-ellipsis w-full overflow-clip">
					${this.badge}
					<slot/>
				</div>
			</div>
		`
	}
}
